<?php 
// Welcome to 乐众财务& 管理系统
// Copyright (c)  http://www.lzsys.com/ All rights reserved.
// Business authorization email server@lzsys.com
// 欢迎使用乐众财务&管理系统
// [7i24星外云服务器应用 功能模块]
if ($addons_config['path'] <> "xingwai") {
    error();
} 

/**
 * 获取随机密码
 */
function xingwai_getpass($len, $chars = null) {
    if (is_null($chars)) {
        $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
    } 
    mt_srand(10000000 * (float)microtime());
    for ($i = 0, $str = '', $lc = strlen($chars) - 1; $i < $len; $i++) {
        $str .= $chars[mt_rand(0, $lc)];
    } 
    return $str;
} 
/**
 * 检测接口通讯
 */
function xingwai_status_vhost($plugin) {
    $status = array('status' => false, 'msg' => "星外渠道不支持检测", 'data' => array());

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * 读取商品配置的费率 这个是自定义方法  方法名称可以自己设定
 */

function xingwai_get_time($plugin, $asset_data) {
    $buytime = $asset_data['buytime']; // 读取费率  管理员后台添加资产时 可自己写费率   当客户购买时 需要按照以下方式获取费率 这些费率是写到配置文件的
    $time_code = $asset_data['buytime'] . "_code"; // 费率代码
    $buytime = $asset_data['remark'][$time_code]; // 获得商品中的费率
    if (!$buytime) {
        $buytime = $asset_data['buytime'];
    } 
    return $buytime;
} 
/**
 * 续费资产
 */
function xingwai_renew_vhost($plugin) {
    $asset_data = $plugin->asset_data(); // 请求过来的数据  里面包含了 用户请求的数据信息  可通过打印数组查看全部 
    $api_config = $plugin->api_config(); // 渠道数据   里面包含了渠道相关的数据  在 remark数组下面 可自行输出数组查看
    $apiurl = $api_config['remark']['weburl']; // 渠道域名
    $apiuser = $api_config['remark']['account']; // 代理登录账号
    $apipass = $api_config['remark']['secret']; // 代理登录密码
    $buytime = xingwai_get_time($plugin, $asset_data); // 获得商品中的费率
    $vpsname = $asset_data['account']; // 管理账号
    $method = "renew"; //操作方法
    $checksum = md5($apipass . "7i24.com"); // 签名
    $url = $apiurl . "api/cloudapi.asp"; // 接口地址  
    $period = $buytime; //试用：999，日：0.01，周：0.04，月：0.1，季：0.3，半年：0.6，1-5为年限 
    // [请求数据]
    $data = "?vpsname=" . $vpsname ; // 管理员账号  
    $data .= "&userid=" . $apiuser; // 渠道登录账号
    $data .= "&action=" . $method; // 操作方法
    $data .= "&userstr=" . $checksum; // 签名值
    $data .= "&year=" . $period; // 费率
    $get_api = $url . $data; // 将 接口地址和 请求数据接起来 
    $host_data = $plugin->ide->lzsys_system->curl_get($get_api); // 执行接口请求   整个服务器的开通过程完成由接口方操作，这里只需要请求  等待结果
    $host_data = $plugin->ide->lzsys_system->gbk_utf8($host_data); // 星外接口返回的是GBK  这里转换成UTF8
    parse_str($host_data, $host_arr); //  将接口返回的数据转换成数组
    if ($host_arr['ret'] == "ok" and $host_arr['vpsname'] <> "") {
        // 当 ret=ok  且 vpsname必须有值时  表示开通服务器成功
        $status = array('status' => true,
            'msg' => '续费资产',
            'data' => array(

                ),

            );
    } else {
        // 当 ret不等于ok  且 vpsname没有值时  表示开通服务器失败
        $msg = $host_data; // 将接口返回的错误数据存储到 $msg  
        if ($host_arr['ret'] <> "") {
            // $msg = $host_arr['freehosinfo'];
        } 
        $status = array('status' => false,
            'msg' => '错误数据：' . $msg,
            'data' => $plugin->ide->lzsys_system->json($host_arr),
            );
    } 

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status)); // 将开通结果写入系统通知	
    
} 
/**
 * 启动资产
 */
function xingwai_start_vhost($plugin) {
    $status = array('status' => true, 'msg' => "启动成功", 'data' => array("msg" => $data));

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * 暂停资产
 */
function xingwai_stop_vhost($plugin) {
    $status = array('status' => true, 'msg' => "暂停成功", 'data' => array("msg" => $data));

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * 资产改密
 */
function xingwai_pass_vhost($plugin) {
    $asset_data = $plugin->asset_data(); // 请求过来的数据  里面包含了 用户请求的数据信息  可通过打印数组查看全部 
    $api_config = $plugin->api_config(); // 渠道数据   里面包含了渠道相关的数据  在 remark数组下面 可自行输出数组查看
    $apiurl = $api_config['remark']['weburl']; // 渠道域名
    $apiuser = $api_config['remark']['account']; // 代理登录账号
    $apipass = $api_config['remark']['secret']; // 代理登录密码
    $vpsname = $asset_data['account']; // 管理账号
    $method = "getinfo"; //操作方法
    $checksum = md5($apipass . "7i24.com"); // 签名
    $url = $apiurl . "api/cloudapi.asp"; // 接口地址   
    // [请求数据]
    $data = "?vpsname=" . $vpsname ; // 管理员账号  
    $data .= "&userid=" . $apiuser; // 渠道登录账号
    $data .= "&action=" . $method; // 操作方法
    $data .= "&userstr=" . $checksum; // 签名值
    $get_api = $url . $data; // 将 接口地址和 请求数据接起来 
    $host_data = $plugin->ide->lzsys_system->curl_get($get_api); // 执行接口请求   整个服务器的开通过程完成由接口方操作，这里只需要请求  等待结果
    $host_data = $plugin->ide->lzsys_system->gbk_utf8($host_data); // 星外接口返回的是GBK  这里转换成UTF8
    parse_str($host_data, $host_arr); //  将接口返回的数据转换成数组
    if ($host_arr['ret'] == "ok" and $host_arr['vpsname'] <> "") {
        // 当 ret=ok  且 vpsname必须有值时  表示开通服务器成功
        $post = $asset_data['post'];

        $asset_data['remark']['account'] = $host_arr['vpsname'];
        $asset_data['remark']['secret'] = $host_arr['vpspassword'];

        if (strtotime($asset_data['remark']['begin_time'])) {
            $asset_data['remark']['begin_time'] = strtotime($asset_data['remark']['begin_time']);
        } 
        if (strtotime($asset_data['remark']['end_time'])) {
            $asset_data['remark']['end_time'] = strtotime($host_arr['endtime']);
        } 

        if ($asset_data['remark']['vhost_describe'] == "0" or $asset_data['remark']['vhost_describe'] == "") {
            $asset_data['remark']['vhost_describe'] = "IP " . $host_arr['ip'];
        } 

        unset($asset_data['post']);
        $updata = $plugin->ide->lzsys_system->json($asset_data['remark']);
        $plugin->ide->mysql->up_db("introduce='" . $asset_data['remark']['vhost_describe'] . "',secret='" . $host_arr['vpspassword'] . "',remark='" . $updata . "'", "user_asset", "app_id='" . $plugin->ide->lzsys_system->app_id() . "' and user_asset_id='" . $asset_data['user_asset_id'] . "'");

        $status = array('status' => true,
            'msg' => '获取资产数据成功',
            'data' => array(

                ),

            );
    } else {
        // 当 ret不等于ok  且 vpsname没有值时  表示开通服务器失败
        $msg = $host_data; // 将接口返回的错误数据存储到 $msg  
        if ($host_arr['ret'] <> "") {
            // $msg = $host_arr['freehosinfo'];
        } 
        $status = array('status' => false,
            'msg' => '创建资产失败，错误数据：' . $msg,
            'data' => $plugin->ide->lzsys_system->json($host_arr),
            );
    } 

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status)); // 将开通结果写入系统通知
} 
/**
 * 同步资产数据
 */
function xingwai_get_vhost($plugin) {
    $status = array('status' => false, 'msg' => "星外渠道不支持同步", 'data' => array("msg" => $data));

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * 批量创建资产
 */
function xingwai_creates_vhost($plugin) {
    $status = array('status' => false, 'msg' => "渠道不支持批量添加", 'data' => array("msg" => $data));

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * 读取商品配置的费率 这个是自定义方法  方法名称可以自己设定
 */

function xingwai_get_times($plugin, $asset_data) {
    $buytime = $asset_data['buytime']; // 读取费率  管理员后台添加资产时 可自己写费率   当客户购买时 需要按照以下方式获取费率 这些费率是写到配置文件的
    $time_code = $asset_data['buytime'] . "_code"; // 费率代码
    $buytime = $asset_data['shop_product']['product_remark'][$time_code]; // 获得商品中的费率
    if (!$buytime) {
        $buytime = $asset_data['buytime'];
    } 
    return $buytime;
} 
/**
 * 单个创建资产
 */
function xingwai_create_vhost($plugin) {
    $asset_data = $plugin->asset_data(); // 请求过来的数据  里面包含了 用户请求的数据信息  可通过打印数组查看全部  $asset_data['shop_product']数组中包含了商品数据
    $api_config = $plugin->api_config(); // 渠道数据   里面包含了渠道相关的数据  在 remark数组下面 可自行输出数组查看
    $apiurl = $api_config['remark']['weburl']; // 渠道域名
    $apiuser = $api_config['remark']['account']; // 代理登录账号
    $apipass = $api_config['remark']['secret']; // 代理登录密码
    $buytime = xingwai_get_times($plugin, $asset_data); // 获得商品中的费率
    $productid = $asset_data['shop_product']['product_remark']['product_code']; // 产品ID  商品代码
    if (!$asset_data['shop_product']) {
        $productid = $asset_data['product_code'];
    } 

    $period = $buytime; //试用：999，日：0.01，周：0.04，月：0.1，季：0.3，半年：0.6，1-5为年限
    $vpsname = $asset_data['account']; // 管理账号
    $vpspass = $asset_data['secret']; // 管理密码
    $method = "activate"; //操作方法
    $checksum = md5($apipass . "7i24.com"); // 签名
    $url = $apiurl . "api/cloudapi.asp"; // 接口地址   
    // [请求数据]
    $data = "?vpsname=" . $vpsname ; // 管理员账号  
    $data .= "&VPSpassword=" . $vpspass ; // 管理密码
    if (!preg_match('/(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])[A-Za-z0-9]{8,20}/', $vpspass)) {
        exit("密码至少8位数且包含大写、小写、数字");
    } 
    $data .= "&userid=" . $apiuser; // 渠道登录账号
    $data .= "&action=" . $method; // 操作方法
    $data .= "&userstr=" . $checksum; // 签名值
    $data .= "&idc=" . $idc; // 机房编号
    $data .= "&productid=" . $productid; // 产品编号
    $data .= "&year=" . $period; // 费率
    $get_api = $url . $data; // 将 接口地址和 请求数据接起来 
    if ($asset_data['shop_product']['product_remark']['open_type']) {
        $asset_data['open_type'] = $asset_data['shop_product']['product_remark']['open_type'];
    } 

    if ($asset_data['open_type'] == "admin") {
        $host_arr['ret'] = "ok";
        $host_arr['vpsname'] = $vpsname;
        $host_arr['vpspassword'] = $vpspass;
    } else {
        $host_data = $plugin->ide->lzsys_system->curl_get($get_api); // 执行接口请求   整个服务器的开通过程完成由接口方操作，这里只需要请求  等待结果
        $host_data = $plugin->ide->lzsys_system->gbk_utf8($host_data); // 星外接口返回的是GBK  这里转换成UTF8
        parse_str($host_data, $host_arr); //  将接口返回的数据转换成数组
    } 

    if ($host_arr['ret'] == "ok" and $host_arr['vpsname'] <> "") {
        // 当 ret=ok  且 vpsname必须有值时  表示开通服务器成功
        if ($asset_data['open_type'] == "admin") {
            $status = array('status' => true,
                'msg' => '创建资产成功',
                'data' => array(// 这里可以根据插件返回需要的参数，会自动保存，然后其他地方可调用
                    'account' => $host_arr['vpsname'], // 获得渠道返回的  管理账号
                    'secret' => $host_arr['vpspassword'], // 获得渠道返回的管理密码
                    'vhost_describe' => '', // 资产描述信息
                    'buytime' => $buytime // 资产描述信息
                    ),

                );
        } else {
            $status = array('status' => true,
                'msg' => '创建资产成功',
                'data' => array(// 这里可以根据插件返回需要的参数，会自动保存，然后其他地方可调用
                    'account' => $host_arr['vpsname'], // 获得渠道返回的  管理账号
                    'secret' => $host_arr['vpspassword'], // 获得渠道返回的管理密码
                    'end_time' => strtotime($host_arr['endtime']), // 获得渠道返回的到期时间 并且转为时间戳
                    'vhost_describe' => '', // 资产描述信息
                    'buytime' => $buytime // 资产描述信息
                    ),

                );
        } 
    } else {
        // 当 ret不等于ok  且 vpsname没有值时  表示开通服务器失败
        $msg = $host_data; // 将接口返回的错误数据存储到 $msg  
        if ($host_arr['ret'] <> "") {
            // $msg = $host_arr['freehosinfo'];
        } 
        $status = array('status' => false,
            'msg' => '创建资产失败，错误数据：' . $msg,
            'data' => $plugin->ide->lzsys_system->json($host_arr),

            );
    } 

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status)); // 将开通结果写入系统通知
} 

/**
 * 编辑资产
 */
function xingwai_edit_vhost($plugin) {
    $api_config = $plugin->api_config();
    $asset_data = $plugin->asset_data(); 
    // 由于星外接口不支持编辑产品数据，所以这里直接返回成功
    $get_status['status'] = true;
    if ($get_status['status'] == true) {
        $status = array('status' => true, 'msg' => "编辑成功", 'data' => array());
    } else {
        $status = array('status' => false, 'msg' => $get_status['msg'], 'data' => array());
    } 
    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 

/**
 * 同步删除资产（由于平台是删除到回收站，所以这里只暂停站点，不删除）
 */
function xingwai_dell_vhost($plugin) {
    $asset_data = $plugin->asset_data();
    foreach ($asset_data as $id) {
        if ($id) {
            $stop['status'] = false; // 这里是直接返回失败
            if ($stop['status'] == true) {
                $data = $data . "  <span style='color:blue;'>操作成功：</span>" . $id['remark']['account'] . "<br>";
            } else {
                $data = $data . "  <span style='color:red;'>操作失败：</span>" . $id['remark']['account'] . " 该资产不支持同步删除<br>";
            } 
        } 
    } 

    $status = array('status' => true, 'msg' => "暂停站点成功", 'data' => array("msg" => $data));

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 

/**
 * 同步删除资产（由于平台是回收站删除资产，所以这里也进行删除操作）
 */
function xingwai_dells_vhost($plugin) {
    $asset_data = $plugin->asset_data();
    foreach ($asset_data as $id) {
        if ($id) {
            $stop['status'] = false; // 这里是直接返回失败
            if ($stop['status'] == true) {
                $data = $data . "  <span style='color:blue;'>操作成功：</span>" . $id['remark']['account'] . "<br>";
            } else {
                $data = $data . "  <span style='color:red;'>操作失败：</span>" . $id['remark']['account'] . " 该资产不支持同步删除<br>";
            } 
        } 
    } 

    $status = array('status' => true, 'msg' => "删除站点成功", 'data' => array("msg" => $data));

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * 同步恢复资产（由于平台是从回收站恢复资产，这里对暂停的资产进行启动）
 */
function xingwai_redu_vhost($plugin) {
    $asset_data = $plugin->asset_data();
    foreach ($asset_data as $id) {
        if ($id) {
            $stop['status'] = false; // 这里是直接返回失败
            if ($stop['status'] == true) {
                $data = $data . "  <span style='color:blue;'>操作成功：</span>" . $id['remark']['account'] . "<br>";
            } else {
                $data = $data . "  <span style='color:red;'>操作失败：</span>" . $id['remark']['account'] . " 该资产不支持同步恢复<br>";
            } 
        } 
    } 

    $status = array('status' => true, 'msg' => "启动站点成功", 'data' => array("msg" => $data));

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 

/**
 * 一键登录渠道管理
 */
function xingwai_login_vhost($plugin) {
    $api_config = $plugin->api_config();

    $status = array('status' => false, 'msg' => "该渠道不支持一键登录", 'data' => array());
    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 

/**
 * 资产管理  这里将会跳转到控制面板
 */
function xingwai_admin_vhost($plugin) {
    $api_config = $plugin->api_config();
    $asset_data = $plugin->asset_data();
    $html = '
    <form name="submitname" method="post" action="' . $api_config['remark']['cpurl'] . 'vpsadm/login.asp"> 
    　<input type="hidden" name="vpsname" value="' . $asset_data['remark']['account'] . '">
    <!--<input type="hidden" name="VPSpassword" value="' . $asset_data['remark']['secret'] . '">-->
    <input type="hidden" name="vpspassword" value="' . $asset_data['remark']['secret'] . '">
    　　<input type="hidden" name="pdtcls" value="hst" > 
    <br>
        <input type="submit" style="color: #FFF" value="">
    </form> 
    
    <font color="blue" size="20">正在登录...</font>

    <script language=javascript> 
    document.submitname.submit()
    </script> 

    '; 
    // [销毁登录会话]
    unset($_SESSION['asset_id']); // 跳转第三方或者不能管理的资产则销毁会话
    exit($html);
} 

